import textwrap

from cpl_core.console import Console

from py_to_uxf_core.abc.umlet_creator_abc import UmletCreatorABC
from py_to_uxf_core.model.dimension import Dimension
from py_to_uxf_core.model.position import Position
from py_to_uxf_core.model.python_class import PythonClass
from py_to_uxf_core.model.uml_class import UMLClass


class UmletCreatorService(UmletCreatorABC):

    def __init__(self):
        UmletCreatorABC.__init__(self)

    def generate_xml(self, classes: list[PythonClass]) -> str:
        xml_cls = ''
        default_width = 80
        default_height = 80
        next_x = 10

        for cls in classes:
            uml_cls = UMLClass(cls, Position(next_x, 10), Dimension(default_width, default_height))
            # save class xml
            xml_cls += uml_cls.as_xml()
            next_x += round(uml_cls.dimension.width, -1) + 10

        return f"""\
        <?xml version="1.0" encoding="UTF-8" standalone="no"?>
        <diagram program="umlet" version="14.1.1">
            <zoom_level>10</zoom_level>
            {xml_cls}
        </diagram>
        """.replace('    ', '').replace('\t', '')
